<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- DWXMLSource="extension.xml" -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="html" encoding="utf-8" doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"/>
  <!--Include extension shared xsl-->
  <xsl:include href="../_include/extbase.xsl"/>
  <xsl:template match="/extension">
    <html xmlns="http://www.w3.org/1999/xhtml">
    <head>
    <title>MediaCoder <xsl:value-of select="name"/></title>
    <link href="../_css/style.css" rel="stylesheet"/>
    <script src="x264setup.js" langauge="javascript"></script>
    <xsl:call-template name="InitExtension"/>
    </head>
    <body class="extension" background="/img/back.png" onload="onPageLoad()" onunload="Unload()"> 
<div> 
  <h1 align="center">MediaCoder x264 Setup</h1> 
</div> 
<table id="TABLE1" width="100%" border="0"> 
  <tr> 
    <td bgcolor="#cccccc" colspan="2"><strong>Generic</strong></td> 
  </tr> 
  <tr> 
    <td width="138"></td> 
    <td width="854"></td> 
  </tr> 
  <tr valign="top"> 
    <td width="138"> <p>Mode</p></td> 
    <td width="854"> <p> 
<xsl:call-template name="AddElement"><xsl:with-param name="element" select="elements/element[@id='mode']"/></xsl:call-template>              </p></td> 
  </tr> 
  <tr valign="middle"> 
    <td width="138"> <div id="bq">Bitrate</div></td> 
    <td><xsl:call-template name="AddElement"><xsl:with-param name="element" select="elements/element[@id='bitrate']"/></xsl:call-template> KBps</td> 
  </tr> 
  <tr valign="top"> 
    <td width="138"> <div id="bq">Quality<br/>
      (0~100)
    </div></td> 
    <td><xsl:call-template name="AddElement"><xsl:with-param name="element" select="elements/element[@id='quality']"/></xsl:call-template>
(for quality-based mode only)    </td> 
  </tr> 
  <tr valign="middle"> 
    <td>&nbsp;</td> 
    <td>&nbsp;</td> 
  </tr> 
  <tr valign="middle"> 
    <td bgcolor="#cccccc" colspan="2"><strong>Bitstream Level</strong></td> 
  </tr> 
  <tr valign="middle"> 
    <td width="138">Level Number </td> 
    <td><xsl:call-template name="AddElement"><xsl:with-param name="element" select="elements/element[@id='level']"/></xsl:call-template>		</td> 
  </tr> 
  <tr valign="middle"> 
    <td>&nbsp;</td> 
    <td><table width="100%" border="1"> 
        <tr bgcolor="#CCCCCC" align="center"> 
          <td> Max macroblocks per second </td> 
          <td> Max frame size (macroblocks) </td> 
          <td> Max video bit rate (VCL) for Baseline, Extended and Main Profile </td> 
          <td> Max video bit rate (VCL) for High Profile </td> 
          <td> Max video bit rate (VCL) for High 10 Profile </td> 
          <td> Max video bit rate (VCL) for High 4:2:2 and High 4:4:4 Profile </td> 
          <td> Examples for high resoluton/framerate in this profile </td> 
        </tr> 
        <tr align="center" id="lt"> 
          <td></td> 
          <td></td> 
          <td></td> 
          <td></td> 
          <td></td> 
          <td></td> 
          <td></td>
        </tr> 
      </table></td> 
  </tr> 
  <tr valign="middle"> 
    <td>&nbsp;</td> 
    <td>&nbsp;</td> 
  </tr> 
  <tr valign="middle"> 
    <td bgcolor="#cccccc" colspan="2"><strong>Speed and Quality</strong></td> 
  </tr> 
  <tr> 
    <td width="138"></td> 
    <td></td> 
  </tr> 
  <tr valign="top"> 
    <td width="138"> <p>Subpel Refinement Quality</p></td> 
    <td><xsl:call-template name="AddElement"><xsl:with-param name="element" select="elements/element[@id='subq']"/></xsl:call-template>
      <p>The highest Value is the slowest and highest quality mode. In comparison to value of 5, value of 6 usually gains 0.1-0.4 dB global PSNR with speed costs varying from 25%-100%. Unlike other levels of subq , the behavior of value of 6 does not depend much on frameref and me . Instead, the effectiveness of value of 6 depends mostly upon the number of B-frames used. In normal usage, this means value of 6 has a large impact on both speed and quality in complex, high motion scenes, but it may not have much effect in low-motion scenes. Note that it is still recommended to always set bframes to something other than zero.</p> 
      <p>&nbsp;</p></td> 
  </tr> 
  <tr valign="top"> 
    <td width="138">Frame Reference<br/> 
      (0~16)</td> 
    <td><xsl:call-template name="AddElement"><xsl:with-param name="element" select="elements/element[@id='frameref']"/></xsl:call-template>
      <p>Merely raising the value to 2 gains around 0.15dB PSNR with a 5-10% speed penalty; this seems like a good tradeoff. value of 3 gains around 0.25dB PSNR over value of 1 , which should be a visible difference. Value of 3 is around 15% slower than value of 1 . Unfortunately, diminishing returns set in rapidly. Value of 6 can be expected to gain only 0.05-0.1 dB over value of 3 at an additional 15% speed penalty. Above value of 6 , the quality gains are usually very small. In a fairly typical case, value of 12 will improve global PSNR by a tiny 0.02dB over value of 6 , at a speed cost of 15%-20%.</p> 
      <p>&nbsp;</p></td> 
  </tr> 
  <tr valign="top"> 
    <td width="138">Motion Estimation </td> 
    <td> <p> 
<xsl:call-template name="AddElement"><xsl:with-param name="element" select="elements/element[@id='me']"/></xsl:call-template></p> 
      <p> This option is for choosing the motion estimation search method. Altering this option provides a straightforward quality-vs-speed tradeoff. me= dia is only a few percent faster than the default search, at a cost of under 0.1dB global PSNR. Hexagon Search is a reasonable tradeoff between speed and quality. Uneven Multi-hexagon gains a little under 0.1dB global PSNR, with a speed penalty that varies depending on frameref . At high values of frameref (e.g. 12 or so), Uneven Multi-hexagon is about 40% slower than the&nbsp;Hexagon Search. With frameref=3 , the speed penalty incurred drops to 25%-30%. </p> 
      <p>&nbsp;</p></td> 
  </tr> 
  <tr valign="top"> 
    <td width="138">8x4, 4x8 and 4x4 subpartitions</td> 
    <td> 
        <xsl:call-template name="AddElement"><xsl:with-param name="element" select="elements/element[@id='p8x8dct']"/></xsl:call-template>
      <p>This option enables the use of 8x4, 4x8 and 4x4 subpartitions in predicted macroblocks (in addition to the default partitions). Enabling it results in a fairly consistent 10%-15% loss of speed. This option is rather useless in source containing only low motion, however in some high-motion source, particularly source with lots of small moving objects, gains of about 0.1dB can be expected.</p> 
      <p>&nbsp;</p></td> 
  </tr> 
  <tr valign="top"> 
    <td>Number of B-frames<br/> 
      (0~16)</td> 
    <td><xsl:call-template name="AddElement"><xsl:with-param name="element" select="elements/element[@id='bframes']"/></xsl:call-template>
      <p>In H.264, B-frames are useful: there are new techniques and block types that are possible in B-frames. Usually, even a naive B-frame choice algorithm can have a significant PSNR benefit. It is interesting to note that using B-frames usually speeds up the second pass somewhat, and may also speed up a single pass encode if adaptive B-frame decision is turned off. </p> 
      <p> With adaptive B-frame decision turned off, the optimal value for this setting is usually no more than 1 , or else high-motion scenes can suffer. With adaptive B-frame decision on, it is safe to use higher values; the encoder will reduce the use of B-frames in scenes where they would hurt compression. The encoder rarely chooses to use more than 3 or 4 B-frames; setting this option any higher will have little effect. </p> 
      <p>&nbsp; </p></td> 
  </tr> 
  <tr valign="top"> 
    <td> B-frame Decision</td> 
    <td><xsl:call-template name="AddElement"><xsl:with-param name="element" select="elements/element[@id='b_adapt']"/></xsl:call-template>
      <p>With this option enabled, the encoder will use a reasonably fast decision process to reduce the number of B-frames used in scenes that might not benefit from them as much. You can use b_bias to tweak how B-frame-happy the encoder is. The speed penalty of adaptive B-frames is currently rather modest, but so is the potential quality gain. It usually does not hurt, however. Note that this only affects speed and frametype decision on the first pass. b_adapt and b_bias have no effect on subsequent passes. </p> 
      <p>&nbsp;</p></td> 
  </tr> 
  <tr valign="top"> 
    <td> Pyramid</td> 
    <td>
	<xsl:call-template name="AddElement"><xsl:with-param name="element" select="elements/element[@id='b_pyramid']"/></xsl:call-template>
	<p>You might as well enable this option if you are using &gt;=2 B-frames; as the man page says, you get a little quality improvement at no speed cost. </p> 
      <p>&nbsp;</p></td> 
  </tr> 
  <tr valign="top"> 
    <td> Weighted Prediction </td> 
    <td><xsl:call-template name="AddElement"><xsl:with-param name="element" select="elements/element[@id='weight_b']"/></xsl:call-template>
      <p>In typical cases, there is not much gain with this option. However, in crossfades or fade-to-black scenes, weighted prediction gives rather large bitrate savings. In MPEG-4 ASP, a fade-to-black is usually best coded as a series of expensive I-frames; using weighted prediction in B-frames makes it possible to turn at least some of these into much smaller B-frames. Encoding time cost is minimal, as no extra decisions need to be made. Also, contrary to what some people seem to guess, the decoder CPU requirements are not much affected by weighted prediction, all else being equal. <br/> 
        Unfortunately, the current adaptive B-frame decision algorithm has a strong tendency to avoid B-frames during fades. Until this changes, it may be a good idea to turn off B-frame Decision, if you expect fades to have a large effect in your particular video clip. </p> 
      <p>&nbsp;</p></td> 
  </tr> 
  <tr valign="middle"> 
    <td>&nbsp;</td> 
    <td>&nbsp;</td> 
  </tr> 
  <tr valign="top"> 
    <td bgcolor="#cccccc" colspan="2"><strong>Miscellaneous Preferences</strong></td> 
  </tr> 
  <tr valign="top"> 
    <td></td> 
    <td></td> 
  </tr> 
  <tr valign="top"> 
    <td>Quantization Compression<br/> 
      (0~100)</td> 
    <td> <p> 
<xsl:call-template name="AddElement"><xsl:with-param name="element" select="elements/element[@id='qcomp']"/></xsl:call-template>              </p> 
      <p>This trades off the number of bits allocated to &quot;expensive&quot; high-motion versus &quot;cheap&quot; low-motion frames. At one extreme, value of 0 aims for true constant bitrate. Typically this would make high-motion scenes look completely awful, while low-motion scenes would probably look absolutely perfect, but would also use many times more bitrate than they would need in order to look merely excellent. At the other extreme, value of 100 achieves nearly constant quantization parameter (QP). Constant QP does not look bad, but most people think it is more reasonable to shave some bitrate off of the extremely expensive scenes (where the loss of quality is not as noticeable) and reallocate it to the scenes that are easier to encode at excellent quality.</p> 
      <p>&nbsp;</p></td> 
  </tr> 
  <tr valign="top"> 
    <td> Maximum I-frame interval</td> 
    <td>
	<xsl:call-template name="AddElement"><xsl:with-param name="element" select="elements/element[@id='keyint']"/></xsl:call-template>
      <p>This setting is solely for trading off file seekability against coding efficiency. Value of 250, in 25fps material, this guarantees the ability to seek to within 10 seconds precision. If you think it would be important and useful to be able to seek within 5 seconds of precision, set it to 125 ; this will hurt quality/bitrate slightly. If you care only about quality and not about seekability, you can set it to much higher values. The video stream will still have seekable points as long as there are some scene changes.</p></td> 
  </tr> 
</table> 
<p align="center"> 
  <input type="button" value="Start Transcoding" onclick="SendCommand('transcode')"/> 
</p> 
    </body>
    </html>
  </xsl:template>
</xsl:stylesheet>
